/*******************************************************************************
				Neoinput
				========

		Copyright (C) 2010 Paul Kocialkowski

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <math.h>

#include "config.h"
#include "input.h"

/* Socket file descriptor */
int sock_fd;

/* Struct to store the server address */
struct sockaddr_in server_addr;

void server_connect(char *server_ip, int server_port)
{
	/* Start to open a socket */
	sock_fd=socket(AF_INET, SOCK_STREAM, 0);


	/* Check if the socket is ok */
	if(sock_fd == -1)
	{
		perror("Error in socket()");
		exit(1);
	}
	else
		printf("socket(): OK...\n");

	/* Server address family */
	server_addr.sin_family=AF_INET;

	/* Server port */
	server_addr.sin_port=htons(server_port);

	/* Server address */
	server_addr.sin_addr.s_addr=inet_addr(server_ip);

	/* Set the Rest of the struct to 0 */

	memset(&(server_addr.sin_zero), 0, 8);

	/* Connect and check if the connection is ok */ 
	if(connect(sock_fd, (struct sockaddr *) &server_addr, sizeof(struct sockaddr)) == -1)
	{
		perror("Error in connect()");
		exit(1);
	}
	else
		printf("connect(): OK...\n");
}

void server_disconnect(void)
{
	close(sock_fd);
}

void server_send_device(void)
{
	int i;
	int input_device_use=0, input_count=0;

	/* TODO : Refaire le système proprement, avec un int et des puissances de 10 */

	printf("Sending input type...\n");

	if(input_preset_value_bool("use_touch"))
	{
		input_device_use+=DEVICE_ID_TOUCH*pow(10, input_count);
		input_count++;
	}
	if(input_preset_value_bool("use_accel"))
	{
		input_device_use+=DEVICE_ID_ACCEL*pow(10, input_count);
		input_count++;
	}

	if(input_preset_value_bool("use_button_aux"))
	{
		input_device_use+=DEVICE_ID_BUTTON_AUX*pow(10, input_count);
		input_count++;
	}
	if(input_preset_value_bool("use_button_power"))
	{
		input_device_use+=DEVICE_ID_BUTTON_POWER*pow(10, input_count);
		input_count++;
	}

	if(!write(sock_fd, &input_count, sizeof(input_count)))
	{
		perror("Error in write()");
		exit(1);
	}

	if(server_get_status() != STATUS_OK)
	{
		printf("Bad status.\n");
		exit(1);
	}


	if(!write(sock_fd, &input_device_use, sizeof(input_device_use)))
	{
		perror("Error in write()");
		exit(1);
	}

	if(server_get_status() != STATUS_OK)
	{
		printf("Bad status.\n");
		exit(1);
	}
}

int server_get_status(void)
{
	printf("Getting server status...\n");

	int status=STATUS_ERROR;

	if(!read(sock_fd, &status, sizeof(status)))
	{
		perror("Error in write()");
		exit(1);
	}

	return status;
}
