/*******************************************************************************
				Neoinput
				========

		Copyright (C) 2010 Paul Kocialkowski

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include <unistd.h>
#include <fcntl.h>

#include <string.h>

#include "config.h"

/* TODO : Ajouter un élément touch_speed */
char *input_preset_array[][2]={
{"ip",			NULL},
{"port",		NULL},
{"use_touch",		NULL},
{"use_accel",		NULL},
{"use_button_aux",	NULL},
{"use_button_power",	NULL},
};

char *input_preset_value_get(char *arg)
{
	int i;
	int input_preset_array_index=sizeof(input_preset_array) / (sizeof(char *) * 2);

	for(i=0 ; i < input_preset_array_index ; i++)
		if(strcmp(arg, input_preset_array[i][0]) == 0)
			return input_preset_array[i][1];

	printf("Error: wrong preset argument: \"%s\".\n", arg);

	return NULL;
}

void input_preset_value_set(char *arg, char *val)
{
	int i;
	int input_preset_array_index=sizeof(input_preset_array) / (sizeof(char *) * 2);

	for(i=0 ; i < input_preset_array_index ; i++)
		if(strcmp(arg, input_preset_array[i][0]) == 0)
		{
			input_preset_array[i][1]=val;
			printf("Preset: %s=%s\n", arg, val);
			return;
		}

	printf("Error: wrong preset argument: \"%s\".\n", arg);
	free(val);
}

bool input_preset_value_bool(char *arg)
{
	char *input_preset_value=NULL;
	input_preset_value=input_preset_value_get(arg);

	if(strcmp(input_preset_value, "true") == 0 || strcmp(input_preset_value, "yes") == 0)
		return true;
	else
		return false;
}

void input_preset_close()
{
	int i;
	int input_preset_array_index=sizeof(input_preset_array) / (sizeof(char *) * 2);

	for(i=0 ; i < input_preset_array_index ; i++)
		free(input_preset_array[i][1]);
}

void input_preset_read(char *input_preset)
{
	int input_preset_fd=0;
	char *input_preset_file=NULL;

	char c=0;
	char *arg=NULL;
	char *val=NULL;

	bool arg_lock=true;
	bool val_lock=true;
	bool comment_lock=false;

	int arg_count=0;
	int val_count=0;

	input_preset_file=malloc(strlen(INPUT_PRESET_DIR) + strlen(input_preset) + strlen(".preset") + 1);
	sprintf(input_preset_file, "%s%s.preset", INPUT_PRESET_DIR, input_preset);

	input_preset_fd=open(input_preset_file, O_RDONLY);
	if(input_preset_fd < 0)
	{
		perror("Error while opening preset");
		exit(1);
	}

	arg=malloc(256);
	memset(arg, 0, 256);

	val=malloc(256);
	memset(val, 0, 256);

	while(read(input_preset_fd, &c, sizeof(char)))
	{
		if(c == '\n')
		{
			comment_lock=false;

			if(strcmp(arg, "") == 0 || strcmp(val, "") == 0)
				continue;

			input_preset_value_set(arg, val);

			memset(arg, 0, 256);
			val=malloc(256);
			memset(val, 0, 256);

			arg_lock=true;
			val_lock=true;

			arg_count=0;
			val_count=0;

			continue;
		}
		if(comment_lock)
			continue;
		if(c == '#')
		{
			comment_lock=true;
			continue;
		}
		if(c == '=')
		{
			arg_lock=false;
			continue;
		}
		if((c == ' ' || c == '\t') && (arg_lock || val_lock) || c == '"' || c == '\'')
			continue;

		if(arg_lock)
		{
			arg[arg_count]=c;
			arg_count++;
		}
		else
		{
			if(val_lock)
				val_lock=false;

			val[val_count]=c;
			val_count++;
		}
	}

	close(input_preset_fd);
}

